//****************************************************************************
// @Module        Project Settings
// @Filename      MAIN.C
// @Project       FlashExampleXC88x.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC886CLM-8FF
//
// @Compiler      Keil
//
// @Codegenerator 1.9
//
// @Description   Programm zum Test des D-Flashs by K.Frank
//
// @Funktion	  Bei jedem Start des Controllers wird ein Wert aus dem D-Flash
// @			  Ausgelesen, um 1 erhht, abgespeichert und an Port 3 (LEDs)
// @			  ausgegeben. 
//
//----------------------------------------------------------------------------
// @Date          13.05.2011 17:15:12
//
//****************************************************************************

// USER CODE BEGIN (MAIN_General,1)

// USER CODE END



//****************************************************************************
// @Project Includes
//****************************************************************************

#include "MAIN.H"

// USER CODE BEGIN (MAIN_General,2)
#include <ctype.h>
#include "FlashHandler.h"
// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (MAIN_General,3)
#define FLASH_FIRST_ADDR       BASEADDR	 	
#define FLASH_LAST_ADDR        WORDLINEADDR(96)

#define FLASH_BANK_TO_CHECK    DFLASH0
#define DFL0_SECTOR_ERASE      SECALL


// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (MAIN_General,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (MAIN_General,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (MAIN_General,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (MAIN_General,7)
  unsigned char RecBufFull, RecCount, TrxCount;	   //Keine Ahnung wo die noch gebraucht werden... ohne gehts aber net
  unsigned char volatile gState; 				     //Keine Ahnung wo die noch gebraucht werden... ohne gehts aber net
  unsigned char xdata RecBuffer[BYTES_PER_WORDLINE]; //Keine Ahnung wo die noch gebraucht werden... ohne gehts aber net

// USER CODE END


//****************************************************************************
// @External Prototypes
//****************************************************************************


// USER CODE BEGIN (MAIN_General,8)

// USER CODE END


//****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************

// USER CODE BEGIN (MAIN_General,9)
  bool done=0;
// USER CODE END


//****************************************************************************
// @Function      void MAIN_vInit(void) 
//
//----------------------------------------------------------------------------
// @Description   This function initializes the microcontroller. It is 
//                assumed that the SFRs are in their reset state.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          13.05.2011
//
//****************************************************************************

// USER CODE BEGIN (MAIN_Init,1)

// USER CODE END

void MAIN_vInit(void)
{
  // USER CODE BEGIN (MAIN_Init,2)

  // USER CODE END

  ///  -----------------------------------------------------------------------
  ///  Configuration of the System Clock:
  ///  -----------------------------------------------------------------------
  ///  - On Chip Osc is Selected
  ///  - PLL Mode, NDIV =  20
  ///  - input frequency is 9,6 MHz



  //   FCLK runs at 2 times the frequency of PCLK.
  SFR_PAGE(_su1, noSST);         // switch to page1

  CMCON         =  0x10;         // load Clock Control Register

  SFR_PAGE(_su0, noSST);         // switch to page0


  ///  *********************************************************************************
  ///  Note : All peripheral related IO configurations are done in the 
  ///  respective peripheral modules (alternate functions selection)
  ///  *********************************************************************************

  ///  Initialization of module 'GPIO'
  IO_vInit();

  ///  Initialization of module 'UART (Serial Interface)'
  UART_vInit();


  //   Interrupt Priority

  IP            =  0x00;         // load Interrupt Priority Register
  IPH           =  0x00;         // load Interrupt Priority High Register
  IP1           =  0x00;         // load Interrupt Priority 1 Register
  IPH1          =  0x00;         // load Interrupt Priority 1 High Register


  // USER CODE BEGIN (MAIN_Init,3)

  // USER CODE END

  //// Interrupt structure 2 mode 0 is selected.

  //// Interrupt service routine choice 2 is selected.

  //   globally enable interrupts
  EA            =  1;           

} //  End of function MAIN_vInit


//****************************************************************************
// @Function      void main(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the main function.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          13.05.2011
//
//****************************************************************************

// USER CODE BEGIN (MAIN_Main,1)

// USER CODE END

void main(void)
{
  // USER CODE BEGIN (MAIN_Main,2)
  unsigned char code *EECurrentAddr;
  // USER CODE END

  MAIN_vInit();
  
  IO_vInit();

  // USER CODE BEGIN (MAIN_Main,3)
  SYSCON0 &= 0xFE;
  PORT_PAGE = 0x0;
			
  // USER CODE END
		  
  while(1)
  {

  // USER CODE BEGIN (MAIN_Main,4)


// ----------------BEISPIELROUTINE ZUM TEST DES EEPROMS----------------------------
// --------bei jedem Controller-Neustart wird ein Wert im EEPROM um 
// --------eins erhht und an Port 3 (LEDs beim Easykit) ausgegeben
// --------------------------------------------------------------------------------

if (done==0){	//Nur Flashen, wenn noch nicht geflasht wurde => Flash- Lebensdauer !!
	done=1;	
	EECurrentAddr = (unsigned char code*)FLASH_FIRST_ADDR; //Zeiger auf 1.Speicheradresse der D-Flashbank (0xA000)

	while (FLASH_Ready(DFLASH0) == 0) {;} 		//Warten, bis Flash Bank 0 (0xA000 bis 0xAFFF) bereit ist

  	WLBuf[0]=*EECurrentAddr; 					//Auslesen des Inhalts, speichern in WLBuf (32- Byte Char- Array, siehe FlashHandler.c)

	//--------FLASH SPEICHER LSCHEN----------------------------
	//FLASH Speicher muss vor dem Programmieren gelscht werden
	//----------------------------------------------------------

	if (! FLASH_Erase(DFLASH0,0)){ 			//Flash- Speicher Lschen
			while(1){						
				  IO_vWritePort(P3,0xAA);	//Falls lschen fehlschlgt, 10101010 an LEDs ausgeben und sonst nix mehr machen (Endlosschleife)
				  }
		  }

	while (FLASH_Ready(DFLASH0) == 0) {;} 	//Warten, bis Flash bereit ist

	WLBuf[0]++;								//Wert um 1 erhhen (LEDs)
  
	//--------FLASH Programmieren----------------------------
	//FLASH_Prog() beschreibt den Flash, bergabewert = Zeiger auf
	//den zu beschreibenden Bereich. Die Daten stehen im CHAR- Array
	//WLBUF[], wobei dieser 32 Byte lang ist (=1 Wordline = kleinste
	//zu beschreibende Einheit im Flash- Speicher
	//----------------------------------------------------------

	if (!FLASH_Prog(EECurrentAddr)){ 		//Flash Programmieren																														
			while(1){						
				  IO_vWritePort(P3,0xFF);	//Falls programmieren fehlschlgt, 10101010 an LEDs ausgeben und sonst nix mehr machen (Endlosschleife)
				  }	
			}				
	
	while (FLASH_Ready(DFLASH0) == 0) {;} //Warten, bis Flash bereit ist (Programmierung abgeschlossen)

}

	 IO_vWritePort(P3, *EECurrentAddr) ;  //Inhalt des Flash- Speichers ausgeben


  // USER CODE END

  }

} //  End of function main






// USER CODE END

